class List
  attr_reader :items
  def initialize
    item1 = ListItem.new
    item1.input = 'foo'
    item1.options = [ {:text=>'hoge1', :value=>'hoge1'},
                      {:text=>'hoge2', :value=>'hoge2'} ]
    item2 = ListItem.new
    item2.input = 'bar'
    item2.options = [ MenuOption.new('hoge3'), MenuOption.new('hoge4') ]
    @items = [item1, item2]
  end
end

class MenuOption
  attr_reader :text, :value
  def initialize(value)
    @text = value
    @value = value
  end
end

class ListItem
  attr_accessor :delete, :input, :select1, :select2, :radio1, :radio2
  attr_writer :options
  *ATTR_ACTION_CHECKBOX = :delete
  *ATTR_ACTION_TEXTBOX = :input
  *ATTR_ACTION_SELECT = :select1
  *ATTR_ACTION_SELECT_DYNAMIC = { :name=>:select2, :item_id=>:select2option, :items=>:options }
                        # :text=>:text, :value=>:value ̓IvV
  *ATTR_ACTION_RADIO = :radio1
  *ATTR_ACTION_RADIO_DYNAMIC = { :name=>:radio2, :item_id=>:radio2input, :items=>:options }
  def initialize
    @delete = false
    @input = ''
    @select1 = '2'
    @select2 = ''
    @radio1 = 'B'
    @radio2 = ''
  end
end
