class TodoList
  def initialize
    #todo = Todo.new
    #todo.description = 'eXg'
    #todo.save
  end
  def not_done
    Todo.find_not_done
  end
  def done
    Todo.find_done
  end
end

# ModelɈϏo[W̎c[
=begin
class TodoEdit
  attr_writer :id
  *ATTR_PARAM = :id
  def todo
    Todo.find(@id.to_i)
  end
end
=end

class TodoEdit
  attr_accessor :id
  attr_reader :description, :done
  *ATTR_HIDDEN = :id
  *ATTR_TEXTBOX = :description
  *ATTR_CHECKBOX = :done
  def preprocess
    item = Todo.find(@id.to_i)
    @description = item.description
    @done = item.done
  end
end

# ActiveRecordgꍇi:sqlite3j
# ȉ̃e[uĂs
# CREATE TABLE todo (
#   id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
#   description TEXT NOT NULL,
#   done INTEGER DEFAULT '0' NOT NULL
# );
=begin
require 'rubygems'
require_gem 'activerecord'
ActiveRecord::Base.pluralize_table_names = false
ActiveRecord::Base.establish_connection(
  :adapter => 'sqlite3',
  :dbfile  => 'webapp/todo.db'
)
class Todo < ActiveRecord::Base
  *ATTR_HIDDEN = :id
  *ATTR_PARAM = :description, :done
  *ATTR_LINK = { :name=>:edit_link, :href=>"todoedit.html?id=\#{id}" }
  def self.find_not_done
    find_all("done = 0", "description")
  end
  def self.find_done
    find_all("done = 1", "description")
  end
end
=end


# ActiveRecordgȂꍇi蔲j
class Todo
  attr_reader :id
  attr_accessor :description, :done
  *ATTR_HIDDEN = :id
  *ATTR_PARAM = :description, :done
  *ATTR_LINK = { :name=>:edit_link, :href=>"todoedit.html?id=\#{id}" }
  @@autoincl_id = 0
  @@items = []
  def initialize(desc = '')
    @id = (@@autoincl_id += 1)
    @description = desc
    @done = false
  end
  def save
    @@items.each_index do |i|
      if @@items[i].id == self.id
        @@items[i] = self
        return
      end
    end
    @@items << self
  end
  def self.find_not_done
    ret = []
    @@items.each do |item|
      ret << item if item.done == false
    end
    ret
  end
  def self.find_done
    ret = []
    @@items.each do |item|
      ret << item if item.done == true
    end
    ret
  end
  def self.find(id)
    @@items.each do |item|
      return item if item.id == id
    end
    nil
  end
  def self.delete(id)
    @@items.reject! do |item|
      item.id == id
    end
  end
end
