#!/usr/bin/ruby
require 'rubygems'
require 'webrick'
require_gem 'needle', '>= 1.2.0'

$DEBUG = true

require 'amritahandler'
include WEBrick


# AvP[VfBNgw
app_dir = 'webapp'


s = HTTPServer.new(
  :Port            => 2000,
  :DocumentRoot    => Dir::pwd,
  :DocumentRootOptions => { :FancyIndexing => false }
)

load_rb = Dir.glob("#{app_dir}/*.rb")

Webapp = Module.new
AmritaHandler.setup(Webapp, load_rb, Needle::Registry.new)

# AmritaHandler::CONFIG[:FancyIndexing] = true
s.mount("/#{app_dir}", HTTPServlet::FileHandler, app_dir, AmritaHandler::CONFIG)

Signal.trap(:INT){ s.shutdown }
Signal.trap(:TERM){ s.shutdown }
s.start if __FILE__ == $0
